using System;
using System.Net;
using System.Collections.Generic;
using System.Text;

namespace GoogleWallpaper
{

    public class GoogleImageSearch
    {

        private string _keyword;
        private bool _safe;

        public GoogleImageSearch()
        {
        }

        public string KeyWord
        {
            get { return _keyword; }
            set { _keyword = value; }
        }

        public bool Safe
        {
            get { return _safe; }
            set { _safe = value; }
        }

        public string[] DoSearch()
        {
            Random r = new Random();
            int j = r.Next(0, 100);
            string html = "";
            string url = @"http://images.google.com/images?lr=&imgsz=xxlarge&safe=" + (_safe ? "on" : "off") + "&q=" + _keyword + "&start=" + j + "&sa=N";
            WebClient wc = new WebClient();
            html += wc.DownloadString(url);
            string[] pieces = html.Split(new string[] { "dyn.Img(" }, StringSplitOptions.None);
            string[] images = new string[pieces.Length - 1];
            for (int i = 1; i < pieces.Length; i++) //purposefully starting at 1
            {
                images[i-1] = pieces[i].Split(',')[3].Split('"')[1];
            }
            return images;
        }

    }

}
