using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GoogleWallpaper
{
    public partial class OptionsForm : Form
    {
        public int refreshRate;
        public string keywords;
        public bool safeSearch;
        public bool onlyWallpaper;
        public int stretch;

        public OptionsForm()
        {
            InitializeComponent();
        }

        private void OptionsForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            refreshRate = (int)numericUpDown1.Value;
            keywords = textBox1.Text;
            safeSearch = checkBox1.Checked;
            onlyWallpaper = checkBox3.Checked;
            if (!checkBox2.Checked) stretch = 0;
            else if (keeprate1.Checked) stretch = 1;
            else if (keeprate2.Checked) stretch = 2;
            else if (full.Checked) stretch = 3;
            else stretch = 0;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
            Close();
        }

        private void OptionsForm_Load(object sender, EventArgs e)
        {
            numericUpDown1.Value = refreshRate;
            textBox1.Text = keywords;
            checkBox1.Checked = safeSearch;
            checkBox3.Checked = onlyWallpaper;
            switch (stretch)
            {
                case 1: checkBox2.Checked = true; keeprate1.Checked = true; break;
                case 2: checkBox2.Checked = true; keeprate2.Checked = true; break;
                case 3: checkBox2.Checked = true; full.Checked = true; break;
                default: checkBox2.Checked = false; break;
            }                  
                
        }

        private void tabPage1_Click(object sender, EventArgs e)
        {

        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            linkLabel1.LinkVisited = true;
            System.Diagnostics.Process.Start("http://www.anappaday.com");

        }

        private void linkLabel2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            linkLabel2.LinkVisited = true;
            System.Diagnostics.Process.Start("http://ponkan.ddo.jp");
        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void label7_Click(object sender, EventArgs e)
        {

        }

        private void linkLabel3_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            linkLabel2.LinkVisited = true;
            System.Diagnostics.Process.Start("http://www.opensource.jp/gpl/gpl.ja.html");
        }

    }
}