using System;
using System.Xml;
using System.Runtime.InteropServices;
using System.Net;
using System.Threading;
using System.Collections.Generic;
using System.Windows.Forms;
using System.IO;

using System.Drawing;


namespace GoogleWallpaper
{
    static class Program
    {

        static NotifyIcon _icon = new NotifyIcon();
        static int stretch = 0;
        static bool onlyWallpaper = true;
        static bool safeSearch = true;
        static string keywords = null;
        static int refreshRate = 30;
        static Thread _thread;

        [STAThread]

        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            LoadOptions();

            //ACR̓ǂݍ
            using (Stream s = System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream("GoogleWallpaper.Icon.ico"))
            {
                _icon.Icon = new Icon(s);
            }

            MenuItem[] items = new MenuItem[4];
            items[3] = new MenuItem("I");
            items[3].Click += new EventHandler(Exit_Click);
            items[2] = new MenuItem("About");
            items[2].Click += new EventHandler(About_Click);
            items[1] = new MenuItem("ǎXV");
            items[1].Click += new EventHandler(Update_Click);
            items[0] = new MenuItem("IvV");
            items[0].Click += new EventHandler(Options_Click);

            _icon.DoubleClick += new EventHandler(Update_Click);
            _icon.ContextMenu = new ContextMenu(items);
            _icon.Visible = true;
            _thread = new Thread(ChangeWallpaper);
            _thread.Start();

            Application.Run();
        }

        static void _icon_DoubleClick(object sender, EventArgs e)
        {
            Options_Click(sender, e);
        }

        //static void ChangeWallpaper()
        //{
        //    GoogleImageSearch search = new GoogleImageSearch();
        //    Random r = new Random();
        //    while (true)
        //    {
        //        if (keywords != null && keywords.Length > 0)
        //        {
        //            int attempt = 0;
        //            Exception lastException;
        //            do
        //            {
        //                try
        //                {
        //                    Image campus = new Bitmap(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width, System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height);
        //                    Graphics g = Graphics.FromImage(campus);
        //                    SolidBrush brush = new SolidBrush(Color.White);
        //                    SolidBrush shadow = new SolidBrush(Color.FromArgb(50, 0, 0, 0));
        //                    int jmax = 10;
        //                    Image[] img= new Image[jmax];

        //                    int[] bw = new int[jmax];
        //                    int[] h = new int[jmax];
        //                    int[] w = new int[jmax];
        //                    int[] x = new int[jmax];
        //                    int[] y = new int[jmax];

        //                    for (int j = 0; j < jmax; j++)
        //                    {
        //                        string[] keywordsSplit = keywords.Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);
        //                        int k = r.Next(0, keywordsSplit.Length);
        //                        search.KeyWord = keywordsSplit[k];
        //                        search.Safe = safeSearch;
        //                        string[] images = search.DoSearch();

        //                        //URLXg摜_E[h
        //                        try
        //                        {
        //                            int i = r.Next(0, images.Length);
        //                            string imageUrl = images[i];
        //                            WebClient wc = new WebClient();
        //                            byte[] bytes = wc.DownloadData(imageUrl);
        //                            MemoryStream stream = new MemoryStream(bytes);


        //                        img[j] = Bitmap.FromStream(stream);

        //                        //int h = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height;
        //                        //int w = img.Width * System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height/img.Height;

        //                        //if (w > System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width)
        //                        //{
        //                        //    w = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width;
        //                        //    h = img.Height * System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width / img.Width;
        //                        //}

        //                        //Bitmap dest = new Bitmap(img,w,h);


        //                        int rate = r.Next(20, System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height * 70 / img[j].Height);

        //                        h[j] = rate * img[j].Height / 100;
        //                        w[j] = rate * img[j].Width / 100;
        //                        bw[j] = 20 * h[j] / 1280;

        //                        x[j] = r.Next(0, System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height - h[j] - bw[j]);
        //                        y[j] = r.Next(0, System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width - w[j] - bw[j]);                                }
        //                        catch { j--; }
        //                    }

        //                    int[] tmp = new int[jmax];
        //                    int[] sortar=new int[jmax];

        //                    for (int j = 0; j < jmax; j++) for (int l = 0; l < jmax; l++) if (h[j] < h[l]) tmp[j]++; else if (h[j] == h[l] && j < l) tmp[j]++;
        //                    for (int j = 0; j < jmax; j++) sortar[tmp[j]]=j;


        //                    for (int k = 0; k < jmax; k++)
        //                    {
        //                        int j = sortar[k];
        //                        g.FillRectangle(shadow, x[j] - bw[j] * 8 / 10, y[j] - bw[j] * 8 / 10, w[j] + 2 * bw[j], h[j] + 2 * bw[j]);
        //                        g.FillRectangle(shadow, x[j] - bw[j] * 5 / 10, y[j] - bw[j] * 5 / 10, w[j] + 2 * bw[j], h[j] + 2 * bw[j]);
        //                        g.FillRectangle(brush, x[j] - bw[j], y[j] - bw[j], w[j] + 2 * bw[j], h[j] + 2 * bw[j]);
        //                        g.DrawImage(img[j], x[j], y[j], w[j], h[j]);
        //                    }
                            

        //                    Bitmap dest = new Bitmap(campus);

        //                    string bmpFilename = Directory.GetCurrentDirectory() + "\\temp.bmp";
        //                    dest.Save(bmpFilename, System.Drawing.Imaging.ImageFormat.Bmp);
                            
        //                    //쐬摜t@Cǎɐݒ
        //                    bool result = WinAPI.SystemParametersInfo(WinAPI.SPI_SETDESKWALLPAPER, 0, bmpFilename, WinAPI.SPIF_UPDATEINIFILE | WinAPI.SPIF_SENDWININICHANGE);
        //                    if (!result)
        //                    {
        //                        throw new Exception("ǎXVł܂");
        //                    }
        //                    lastException = null;
        //                }
        //                catch (Exception ex)
        //                {
        //                    lastException = ex;
        //                }
        //            } while (lastException != null && attempt++ < 3);
        //            if (lastException != null)
        //            {
        //                _icon.ShowBalloonTip(5000, "fXNgbvXVł܂", lastException.Message, ToolTipIcon.Error);
        //            }
        //        }
        //        lock (_icon) {
        //            Monitor.Wait(_icon, refreshRate * 60000);
        //        }
        //    }
        //}
        static void ChangeWallpaper()
        {
            GoogleImageSearch search = new GoogleImageSearch();
            Random r = new Random();
            while (true)
            {
                if (keywords != null && keywords.Length > 0)
                {
                    int attempt = 0;
                    Exception lastException;
                    do
                    {
                        try
                        {
                            Image campus = new Bitmap(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width, System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height);
                            Graphics g = Graphics.FromImage(campus);
                            SolidBrush brush = new SolidBrush(Color.White);
                            SolidBrush shadow = new SolidBrush(Color.FromArgb(50, 0, 0, 0));

                            string[] keywordsSplit = keywords.Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);
                            int k = r.Next(0, keywordsSplit.Length);
                            search.KeyWord = keywordsSplit[k];
                            if (onlyWallpaper) search.KeyWord += " wallpaper OR wallpapers OR ǎ";
                            search.Safe = safeSearch;
                            string[] images = search.DoSearch();

                            //URLXg摜_E[h

                            int i = r.Next(0, images.Length);
                            string imageUrl = images[i];
                            WebClient wc = new WebClient();
                            byte[] bytes = wc.DownloadData(imageUrl);
                            MemoryStream stream = new MemoryStream(bytes);

                            Image img = Bitmap.FromStream(stream);

                            int h, w;

                            switch (stretch)
                            {
                                case 1:
                                    h = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height;
                                    w = img.Width * System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height / img.Height;
                                    if (w > System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width)
                                    {
                                        w = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width;
                                        h = img.Height * System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width / img.Width;
                                    }
                                    break;

                                case 2:
                                    h = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height;
                                    w = img.Width * System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height / img.Height;
                                    if (w < System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width)
                                    {
                                        w = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width;
                                        h = img.Height * System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width / img.Width;
                                    }
                                    break;

                                case 3:
                                    h = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height;
                                    w = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width;
                                    break;

                                default:
                                    h = img.Height;
                                    w = img.Width;
                                    break;
                            }

                            Bitmap dest = new Bitmap(img, w, h);

                            string bmpFilename = Directory.GetCurrentDirectory() + "\\temp.bmp";
                            dest.Save(bmpFilename, System.Drawing.Imaging.ImageFormat.Bmp);

                            //쐬摜t@Cǎɐݒ
                            bool result = WinAPI.SystemParametersInfo(WinAPI.SPI_SETDESKWALLPAPER, 0, bmpFilename, WinAPI.SPIF_UPDATEINIFILE | WinAPI.SPIF_SENDWININICHANGE);
                            if (!result)
                            {
                                throw new Exception("ǎɐݒł܂");
                            }
                            lastException = null;
                        }
                        catch (Exception ex)
                        {
                            lastException = ex;
                        }
                    } while (lastException != null && attempt++ < 3);
                    if (lastException != null)
                    {
                        _icon.ShowBalloonTip(5000, "[hĂ", lastException.Message, ToolTipIcon.Error);
                    }
                }
                lock (_icon)
                {
                    Monitor.Wait(_icon, refreshRate * 60000);
                }
            }
        }

        static void Exit_Click(object sender, EventArgs e)
        {
            _icon.Visible = false;
            _icon.Dispose();
            SaveOptions();
            Environment.Exit(0);
        }

        private static void LoadOptions()
        {
            try
            {
                XmlDocument doc = new XmlDocument();
                doc.Load("GoogleWallpaper.WinApp.jedi");
                refreshRate = Int32.Parse(doc.DocumentElement.SelectSingleNode("RefreshRate").InnerText);
                keywords = doc.DocumentElement.SelectSingleNode("Keywords").InnerText;
                onlyWallpaper = Boolean.Parse(doc.DocumentElement.SelectSingleNode("onlyWallpaper").InnerText);
                safeSearch = Boolean.Parse(doc.DocumentElement.SelectSingleNode("SafeSearch").InnerText);
                stretch = Convert.ToInt16(doc.DocumentElement.SelectSingleNode("Stretch").InnerText);
            }
            catch (Exception)
            {
                //not there
            }
        }

        private static void SaveOptions()
        {
            try
            {
                using (XmlWriter write = XmlWriter.Create("GoogleWallpaper.WinApp.jedi"))
                {
                    write.WriteStartDocument();
                    write.WriteStartElement("GoogleWallpaper");
                    write.WriteElementString("RefreshRate", refreshRate.ToString());
                    write.WriteElementString("Keywords", keywords.ToString());
                    write.WriteElementString("SafeSearch", safeSearch.ToString()); ;
                    write.WriteElementString("onlyWallpaper", onlyWallpaper.ToString()); ;
                    write.WriteElementString("Stretch", stretch.ToString());
                    write.WriteEndElement();
                    write.WriteEndDocument();
                    write.Close();
                }
            }
            catch (Exception)
            {
                //not there
            }
        }

        static void About_Click(object sender, EventArgs e)
        {
            OptionsForm f = new OptionsForm();
            f.tabControl1.SelectedTab=f.tabPage3;
            f.ShowDialog();
        }

        static void Update_Click(object sender, EventArgs e)
        {
            lock (_icon)
            {
                Monitor.PulseAll(_icon);
            }
        }

        static void Options_Click(object sender, EventArgs e)
        {
            OptionsForm f = new OptionsForm();
            f.safeSearch = safeSearch;
            f.keywords = keywords;
            f.refreshRate = refreshRate;
            f.stretch = stretch;
            f.onlyWallpaper = onlyWallpaper;
            if (f.ShowDialog() == DialogResult.OK)
            {
                stretch = f.stretch;
                safeSearch = f.safeSearch;
                refreshRate = f.refreshRate;
                keywords = f.keywords;
                onlyWallpaper = f.onlyWallpaper;
                lock (_icon)
                {
                    Monitor.PulseAll(_icon);
                }
            }
        }

    }

    public class WinAPI
    {
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern bool SystemParametersInfo(int uAction, int uParam, string lpvParam, int fuWinIni);
        public const int SPI_SETDESKWALLPAPER = 20; 
        public const int SPIF_UPDATEINIFILE = 0x01;
        public const int SPIF_SENDWININICHANGE = 0x02;
    }  

}